/* 
 *  gstalker stock charter
 * 
 *  Copyright (c) 1998 Stefan S. Stratigakos
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, 
 *  USA.
 */

#include "myheader.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>


/*********************************************************************************/
void update_stats_bar()
{
	char tstring[250], tstring2[25], tstring3[25];
	float tfloat;
	extern int contract_high_flag, contract_low_flag, last_date_flag, last_close_flag;
	extern int net_change_flag, entries;
	extern GtkWidget *info_frame;
	extern float *close_array, maxhigh, maxlow;
	extern long *date_array;
	
	tstring[0] = 0;
	if (contract_high_flag)
	{
		strcpy(tstring, "CH=");
		sprintf(tstring2, "%g", maxhigh);
		strcat(tstring, tstring2);
	}
 	if (contract_low_flag)
       	{
       		strcat(tstring, " CL=");
       		sprintf(tstring2, "%g", maxlow);
       		strcat(tstring, tstring2);
       	}
       	if (last_date_flag)
       	{
       		strcat(tstring, " LD=");
		sprintf(tstring2, "%ld", date_array[entries - 1]);
		tstring3[0] = tstring2[4];
        	tstring3[1] = tstring2[5];
        	tstring3[2] = '/';
        	tstring3[3] = tstring2[6];
        	tstring3[4] = tstring2[7];
        	tstring3[5] = '/';
        	tstring3[6] = tstring2[0];
        	tstring3[7] = tstring2[1];
        	tstring3[8] = tstring2[2];
        	tstring3[9] = tstring2[3];
        	tstring3[10] = 0;
        	strcat(tstring, tstring3);
        }
        if (last_close_flag)
        {
       		strcat(tstring, " LC=");
       		sprintf(tstring2, "%g", close_array[entries - 1]);
       		strcat(tstring, tstring2);
       	}
       	if (net_change_flag)
       	{
       		strcat(tstring, " NC= ");
       		tfloat = close_array[entries - 1] - close_array[entries - 2];
       		sprintf(tstring2, "%g", tfloat);
       		strcat(tstring, tstring2);
       	}
       	gtk_statusbar_push(GTK_STATUSBAR(info_frame), 1, tstring);
}       
/**********************************************************************************/
void exit_yesno_window()
{
	extern GtkWidget *yesno_window;
	extern int yesno_flag;
	
	gtk_widget_destroy(yesno_window);
	yesno_flag = 0;
}
/***********************************************************************************/
void exit_message()
{
	extern GtkWidget *message_window;
	extern int message_flag;
	
	gtk_widget_destroy(message_window);
	message_flag = 0;
}
/****************************************************************************************/
void display_message()
{
	GtkWidget *hbox, *vbox, *hbox2, *label, *button, *hsep;
	extern GtkWidget *message_window;
	extern gchar *error_message;
	extern int message_flag;
	
	
	if (message_flag)
		return;
	message_window = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_signal_connect (GTK_OBJECT (message_window), "delete_event",
			    GTK_SIGNAL_FUNC (exit_message), NULL);
	gtk_signal_connect (GTK_OBJECT (message_window), "destroy",
			    GTK_SIGNAL_FUNC (exit_message), NULL);
	gtk_window_position(GTK_WINDOW (message_window), GTK_WIN_POS_CENTER);
	gtk_window_set_title (GTK_WINDOW (message_window), "Error");
	gtk_widget_set_usize(GTK_WIDGET (message_window), 0, 0);
	
	
	vbox = gtk_vbox_new (FALSE, 10);
	gtk_container_add (GTK_CONTAINER (message_window), vbox);
      	gtk_container_border_width (GTK_CONTAINER (vbox), 0);
      	gtk_widget_show (vbox);
      	
      	hbox2 = gtk_hbox_new (FALSE, 0);
      	gtk_box_pack_start (GTK_BOX (vbox), hbox2, FALSE, TRUE, 0);
      	gtk_container_border_width (GTK_CONTAINER (hbox2), 10);
      	gtk_widget_show (hbox2);
      	
	label = gtk_label_new(error_message);
	gtk_box_pack_start (GTK_BOX (hbox2), label, FALSE, TRUE, 0);
        gtk_widget_show(label);
        
        hsep = gtk_hseparator_new();
	gtk_box_pack_start (GTK_BOX (vbox), hsep, FALSE, TRUE, 0);
        gtk_widget_show(hsep);
        
        hbox = gtk_hbutton_box_new();
        gtk_container_border_width (GTK_CONTAINER (hbox), 10);
      	gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, TRUE, 0);
      	gtk_hbutton_box_set_spacing_default(10);
        gtk_hbutton_box_set_layout_default(GTK_BUTTONBOX_END);
      	gtk_widget_show(hbox);
        
      	button = gtk_button_new_with_label("OK");
      	gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			    GTK_SIGNAL_FUNC (exit_message), NULL);
      	gtk_widget_show (button);
      	
      	GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
      	gtk_widget_grab_default (button);
      	message_flag = 1;
      	gtk_widget_show(message_window);
}
/*******************************************************************************/
void about()
{
	GtkWidget *window, *hbox, *vbox, *label, *button, *hsep;
	
	
	window = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_signal_connect (GTK_OBJECT (window), "delete_event",
			    GTK_SIGNAL_FUNC (gtk_widget_destroy), NULL);
	gtk_signal_connect (GTK_OBJECT (window), "destroy",
			    GTK_SIGNAL_FUNC (gtk_widget_destroy), NULL);
	gtk_window_position(GTK_WINDOW (window), GTK_WIN_POS_CENTER);
	gtk_window_set_title (GTK_WINDOW (window), "About");
	gtk_widget_set_usize(GTK_WIDGET (window), 300, 0);
	
	
	vbox = gtk_vbox_new (FALSE, 10);
	gtk_container_add (GTK_CONTAINER (window), vbox);
      	gtk_container_border_width (GTK_CONTAINER (vbox), 0);
      	gtk_widget_show (vbox);
      	
	label = gtk_label_new("gstalker  V1.0b3");
	gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, TRUE, 10);
        gtk_widget_show(label);
        
        hsep = gtk_hseparator_new();
	gtk_box_pack_start (GTK_BOX (vbox), hsep, TRUE, TRUE, 0);
        gtk_widget_show(hsep);
        
        hbox = gtk_hbutton_box_new();
        gtk_container_border_width (GTK_CONTAINER (hbox), 10);
      	gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, TRUE, 0);
      	gtk_hbutton_box_set_spacing_default(10);
        gtk_hbutton_box_set_layout_default(GTK_BUTTONBOX_END);
      	gtk_widget_show(hbox);
        
      	button = gtk_button_new_with_label("OK");
      	gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, TRUE, 0);
      	gtk_signal_connect_object (GTK_OBJECT (button), "clicked",
			    GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT(window));
      	gtk_widget_show (button);
      	
      	GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
      	gtk_widget_grab_default (button);
      	gtk_widget_show(window);
}
/************************************************************************************/
void exit_init_window()
{
	extern GtkWidget *init_window;
	
	gtk_widget_destroy(init_window);
}
/*********************************************************************************/
void exit_export_options_window()
{
	extern GtkWidget *export_options_window;
	extern int export_options_flag;
	
	gtk_widget_destroy(export_options_window);
	export_options_flag = 0;
}
/*********************************************************************************/
void exit_import_options_window()
{
	extern GtkWidget *import_options_window;
	extern int import_options_flag;
	
	gtk_widget_destroy(import_options_window);
	import_options_flag = 0;
}
/*********************************************************************************/
void exit_alert_scan_window()
{
	extern GtkWidget *alert_scan_window;
	extern int alert_scan_flag;
	
	gtk_widget_destroy(alert_scan_window);
	alert_scan_flag = 0;
}
/*********************************************************************************/
void exit_progwindow()
{
	extern GtkWidget *progwindow;
	
	gtk_widget_destroy(progwindow);
}
/*********************************************************************************/
void exit_openfile()
{
	extern GtkWidget *openfile;
	extern int openfile_flag;
	
	gtk_widget_destroy(openfile);
	openfile_flag = 0;
}
/*********************************************************************************/
void exit_edit_chart_window()
{
	extern GtkWidget *edit_chart_window;
	extern int edit_chart_flag;
	
	gtk_widget_destroy(edit_chart_window);
	edit_chart_flag = 0;
}
/*********************************************************************************/
void exit_workwith_charts_window()
{
	extern GtkWidget *workwith_charts_window;
	extern int workwith_charts_flag;
	
	gtk_widget_destroy(workwith_charts_window);
	workwith_charts_flag = 0;
}
/*********************************************************************************/
void exit_goto_chart_window()
{
	extern GtkWidget *goto_chart_window;
	extern int goto_chart_flag;
	
	gtk_widget_destroy(goto_chart_window);
	goto_chart_flag = 0;
}
/*********************************************************************************/
void exit_edit_group_window()
{
	extern GtkWidget *edit_group_window;
	extern int edit_group_flag;
	
	gtk_widget_destroy(edit_group_window);
	edit_group_flag = 0;
}
/*********************************************************************************/
void exit_rename_group_window()
{
	extern GtkWidget *rename_group_window;
	extern int rename_group_flag;
	
	gtk_widget_destroy(rename_group_window);
	rename_group_flag = 0;
}
/*********************************************************************************/
void exit_workwith_groups_window()
{
	extern GtkWidget *workwith_groups_window;
	extern int workwith_groups_flag;
	
	gtk_widget_destroy(workwith_groups_window);
	workwith_groups_flag = 0;
}
/*********************************************************************************/
void exit_new_group_window()
{
	extern GtkWidget *new_group_window;
	extern int new_group_flag;
	
	gtk_widget_destroy(new_group_window);
	new_group_flag = 0;
}
/*********************************************************************************/
void exit_edit_options_window()
{
	extern GtkWidget *edit_options_window;
	extern int edit_options_flag;
	
	gtk_widget_destroy(edit_options_window);
	edit_options_flag = 0;
}
/*********************************************************************************/
void exit_indicator_window()
{
	extern GtkWidget *edit_indicator_window;
	extern int edit_indicators_flag;
	
	gtk_widget_destroy(edit_indicator_window);
	edit_indicators_flag = 0;
}
/**********************************************************************************/
void show_info_bar()
{
	extern GtkWidget *info_frame, *info_bar;

	
	info_frame = gtk_statusbar_new ();
      	gtk_box_pack_start (GTK_BOX (info_bar), info_frame, TRUE, TRUE, 2);
      	gtk_widget_show (info_frame);
      	update_stats_bar();
}
/*********************************************************************************/
void hide_info_bar()
{
	extern GtkWidget *info_frame;
	
	gtk_widget_destroy(info_frame);
}
/**********************************************************************************/
void show_data_bar()
{
	extern GtkWidget *data_frame, *data_bar;
	
	data_frame = gtk_statusbar_new ();
      	gtk_box_pack_start (GTK_BOX (data_bar), data_frame, TRUE, TRUE, 2);
      	gtk_widget_show (data_frame);
}
/*********************************************************************************/
void hide_data_bar()
{
	extern GtkWidget *data_frame;
	
	gtk_widget_destroy(data_frame);
}
/*********************************************************************************/
void create_config()
{
	int tint; 
	char tstring[250];
	FILE *outfile;
	extern char *config_file;
	
	
	outfile = fopen(config_file, "wb");
	if (! outfile)
	{
		printf("Can't create config_file in ~/gstalker ! Aborting program!");
		gtk_main_quit();
	}
	strncpy(tstring, " ", 249);
	fwrite(tstring, 250, 1, outfile);
	tint = 0;
	fwrite(&tint, sizeof(int), 1, outfile);
	tint = 1;
	fwrite(&tint, sizeof(int), 1, outfile);
	fwrite(&tint, sizeof(int), 1, outfile);
	fwrite(&tint, sizeof(int), 1, outfile);
	fwrite(&tint, sizeof(int), 1, outfile);
	fwrite(&tint, sizeof(int), 1, outfile);
	fwrite(&tint, sizeof(int), 1, outfile);
	fwrite(&tint, sizeof(int), 1, outfile);
	fwrite(&tint, sizeof(int), 1, outfile);
	fwrite(&tint, sizeof(int), 1, outfile);
	fwrite(&tint, sizeof(int), 1, outfile);
	fwrite(&tint, sizeof(int), 1, outfile);
	fwrite(&tint, sizeof(int), 1, outfile);
	fwrite(&tint, sizeof(int), 1, outfile);
	fwrite(&tint, sizeof(int), 1, outfile);
	fclose(outfile);
}
/***********************************************************************************/
void exit_program()
{
	char tstring[250];
	FILE *outfile;
	extern char *config_file, *last_group;
	
	outfile = fopen(config_file, "r+b");
	if (! outfile)
	{
		create_config();
		outfile = fopen(config_file, "r+b");
	}
	strncpy(tstring, last_group, 249);
	fwrite(tstring, 250, 1, outfile);
	fclose(outfile);
	gtk_main_quit();
}
/*************************************************************************************/
void read_config()
{
	char tstring[250], tstring2[250];
	FILE *infile;
	extern char *config_file, *last_group;
	extern int date_flag, open_flag, high_flag, low_flag, close_flag, volume_flag, openi_flag;
	extern int top_enable_flag, bottom_enable_flag, bars, contract_high_flag;
	extern int contract_low_flag, last_date_flag, last_close_flag, net_change_flag;
	
	
	infile = fopen(config_file, "rb");
	if (! infile)
	{
		create_config();
		infile = fopen(config_file, "rb");
	}
	fread(tstring, 250, 1, infile);
	if (tstring[0] == ' ')
		tstring2[0] = 0;
	else
		sscanf(tstring, "%s", tstring2);
	if (last_group != NULL)
		free(last_group);
	last_group = (char *)malloc(sizeof(tstring2) + 1);
	strcpy(last_group, tstring2);
	fread(&bars, sizeof(int), 1, infile);
	fread(&top_enable_flag, sizeof(int), 1, infile);
	fread(&bottom_enable_flag, sizeof(int), 1, infile);
	fread(&contract_high_flag, sizeof(int), 1, infile);
	fread(&contract_low_flag, sizeof(int), 1, infile);
	fread(&last_date_flag, sizeof(int), 1, infile);
	fread(&last_close_flag, sizeof(int), 1, infile);
	fread(&net_change_flag, sizeof(int), 1, infile);
	fread(&date_flag, sizeof(int), 1, infile);
	fread(&open_flag, sizeof(int), 1, infile);
	fread(&high_flag, sizeof(int), 1, infile);
	fread(&low_flag, sizeof(int), 1, infile);
	fread(&close_flag, sizeof(int), 1, infile);
	fread(&volume_flag, sizeof(int), 1, infile);
	fread(&openi_flag, sizeof(int), 1, infile);
	fclose(infile);
}
/***********************************************************************************/
void toggle_volume()
{
	extern int volume_button_flag, chartflag;
	extern draw();
	
	if (chartflag == 0)
		return;
		
	if (volume_button_flag)
		volume_button_flag--;
	else
		volume_button_flag++;
	draw();
}
/************************************************************************************/
void toggle_grid()
{
	extern int grid_flag, chartflag;
	extern draw();
	
	
	if (chartflag == 0)
		return;
	if (grid_flag)
		grid_flag--;
	else
		grid_flag++;
	draw();
}
/*************************************************************************************/
void destroy_alert_window()
{
	extern GtkWidget *alert_window;
	extern int alert_window_flag;
	
	gtk_widget_destroy(alert_window);
	alert_window_flag = 0;
}
/*************************************************************************************/
void destroy_data_window()
{
	extern GtkWidget *data_window;
	extern int data_window_flag;
	
	gtk_widget_destroy(data_window);
	data_window_flag = 0;
}
/*****************************************************************************************/
void show_data_window()
{
	
	glong arraypointer, tlong;
    	gchar tstring[250], tstring2[25], *tstringpointer;
    	gint tint;
    	gchar *format7[] = {"Date", "Open", "High", "Low", "Close", "Volume", "Open Int"};
    	GtkWidget *vbox;
    	extern GtkWidget *data_window, *data_window_clist;
    	extern float *open_array, *high_array, *low_array, *close_array;
    	extern long *date_array, *volume_array, *openint_array;
    	extern int data_window_flag, entries, chartflag, open_file_flag;
    	extern char symbol[SYMBOL_SIZE], name[NAME_SIZE], *groupfilename;

    
	
    	if (chartflag == 0)
    		return;
    	if (data_window_flag)
    	{
        	gtk_clist_freeze(GTK_CLIST(data_window_clist));
        	gtk_clist_clear(GTK_CLIST(data_window_clist));
        	gtk_clist_thaw(GTK_CLIST(data_window_clist));
        }
        else
        {
        	data_window_flag = 1;
        	data_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
        	gtk_signal_connect (GTK_OBJECT (data_window), "delete_event",
			    	    GTK_SIGNAL_FUNC (destroy_data_window), NULL);
		gtk_signal_connect (GTK_OBJECT (data_window), "destroy",
			    	    GTK_SIGNAL_FUNC (destroy_data_window), NULL);
        	gtk_container_border_width (GTK_CONTAINER (data_window), 10);
        	gtk_window_position(GTK_WINDOW (data_window), GTK_WIN_POS_CENTER);
		gtk_widget_set_usize(GTK_WIDGET (data_window), 585, 300);

		vbox = gtk_vbox_new (FALSE, 0);
        	gtk_container_add (GTK_CONTAINER (data_window), vbox);
        	gtk_widget_show (vbox);
	
		data_window_clist = gtk_clist_new_with_titles (7, format7);
		gtk_clist_set_column_width(GTK_CLIST(data_window_clist), 0, 70);
		gtk_clist_set_column_width(GTK_CLIST(data_window_clist), 1, 70);
		gtk_clist_set_column_width(GTK_CLIST(data_window_clist), 2, 70);
		gtk_clist_set_column_width(GTK_CLIST(data_window_clist), 3, 70);
		gtk_clist_set_column_width(GTK_CLIST(data_window_clist), 4, 70);
		gtk_clist_set_column_width(GTK_CLIST(data_window_clist), 5, 70);
		gtk_clist_set_column_width(GTK_CLIST(data_window_clist), 6, 70);
		for (tint = 0; tint < 7; tint++)
			gtk_clist_set_column_justification(GTK_CLIST(data_window_clist),tint,GTK_JUSTIFY_LEFT);
        	gtk_clist_set_selection_mode (GTK_CLIST (data_window_clist), GTK_SELECTION_BROWSE);
        	gtk_clist_set_policy (GTK_CLIST (data_window_clist), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
        	gtk_box_pack_start (GTK_BOX (vbox), data_window_clist, TRUE, TRUE, 0);
        	gtk_widget_show(data_window_clist);
      	}
      	gtk_clist_freeze(GTK_CLIST(data_window_clist));
        for (arraypointer = 0; arraypointer < entries; arraypointer++)
        {
           	tlong = gtk_clist_append(GTK_CLIST(data_window_clist), NULL);
           	sprintf(tstring, "%ld", date_array[arraypointer]);
           	tstring2[0] = tstring[4];
           	tstring2[1] = tstring[5];
           	tstring2[2] = '/';
           	tstring2[3] = tstring[6];
           	tstring2[4] = tstring[7];
           	tstring2[5] = '/';
           	tstring2[6] = tstring[0];
           	tstring2[7] = tstring[1];
           	tstring2[8] = tstring[2];
           	tstring2[9] = tstring[3];
           	tstring2[10] = 0;
           	gtk_clist_set_text(GTK_CLIST(data_window_clist), tlong, 0, tstring2);
        	sprintf(tstring, "%g", open_array[arraypointer]);
        	gtk_clist_set_text(GTK_CLIST(data_window_clist), tlong, 1, tstring);
        	sprintf(tstring, "%g", high_array[arraypointer]);
        	gtk_clist_set_text(GTK_CLIST(data_window_clist), tlong, 2, tstring);
        	sprintf(tstring, "%g", low_array[arraypointer]);
        	gtk_clist_set_text(GTK_CLIST(data_window_clist), tlong, 3, tstring);
        	sprintf(tstring, "%g", close_array[arraypointer]);
        	gtk_clist_set_text(GTK_CLIST(data_window_clist), tlong, 4, tstring);
        	sprintf(tstring, "%ld", volume_array[arraypointer]);
        	gtk_clist_set_text(GTK_CLIST(data_window_clist), tlong, 5, tstring);
        	sprintf(tstring, "%ld", openint_array[arraypointer]);
        	gtk_clist_set_text(GTK_CLIST(data_window_clist), tlong, 6, tstring);
        }
        gtk_clist_thaw(GTK_CLIST(data_window_clist));
        if (open_file_flag == 1)
	{
		strcpy(tstring, "Data Window: ");
		strcat(tstring, name);
		strcat(tstring, " (");
		strcat(tstring, symbol);
		strcat(tstring, ")");
	}
	else
	{
		strcpy(tstring, "Data Window: [");
		tstringpointer = strrchr(groupfilename, '/');
		strcat(tstring, tstringpointer + 1);
		strcat(tstring, "] - ");
		strcat(tstring, name);
		strcat(tstring, " (");
		strcat(tstring, symbol);
		strcat(tstring, ")");
	}
	gtk_window_set_title (GTK_WINDOW (data_window), tstring);
        gtk_widget_show(data_window);
}
/***************************************************************************************/
void ok_goto_chart()
{
    	gint tint;
    	GList *list;
    	extern GtkWidget *goto_chart_clist;
    	extern char *error_message, nothing_selected[];
    	extern int group_pointer, data_window_flag, edit_indicators_flag;
	extern load_file(), edit_indicators();
    	

	list = GTK_CLIST (goto_chart_clist)->selection;
	if (list)
	{
      		tint = (int) list->data;
      		group_pointer = tint;
		load_file();
		if (data_window_flag == 1)
			show_data_window();
		if (edit_indicators_flag)
			edit_indicators();
		exit_goto_chart_window();
    	}
    	else
    	{
    		error_message = nothing_selected;
		display_message();
    	}
}
/***************************************************************************************/
void goto_chart()
{
   	char tstring[250], tstring2[250], *line[4], *text[] = {"Symbol", "Name", "Start", "End"};
   	char tstring3[250], tstring4[15], tstring5[5];
   	gint tint;
   	FILE *infile, *infile2;
   	unsigned long tlong, records;
   	GtkWidget *vbox, *hbox, *button, *button2, *button3, *hsep;
	extern GtkWidget *goto_chart_window, *goto_chart_clist;
	extern int group_size, chartflag, goto_chart_flag, open_file_flag, group_pointer;
	extern char *groupfilename, *datapath, *error_message, cant_open_group[];
	extern help_goto_chart_window();
	
   	
   	if (chartflag == 0)
   		return;
   	if (open_file_flag)
   		return;
	if (goto_chart_flag)
	{
		gtk_clist_select_row(GTK_CLIST(goto_chart_clist), group_pointer, 0);
       		gtk_clist_moveto(GTK_CLIST(goto_chart_clist), group_pointer, 0, 0.5, 0);
   		return;
   	}
   		
	goto_chart_window = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_signal_connect (GTK_OBJECT (goto_chart_window), "delete_event",
			    GTK_SIGNAL_FUNC (exit_goto_chart_window), NULL);
	gtk_signal_connect (GTK_OBJECT (goto_chart_window), "destroy",
			    GTK_SIGNAL_FUNC (exit_goto_chart_window), NULL);
	gtk_window_position(GTK_WINDOW (goto_chart_window), GTK_WIN_POS_CENTER);
	gtk_window_set_title (GTK_WINDOW (goto_chart_window), "Goto Chart");
	gtk_widget_set_usize(GTK_WIDGET (goto_chart_window), 0, 0);
	
	vbox = gtk_vbox_new (FALSE, 0);
      	gtk_container_border_width (GTK_CONTAINER (vbox), 0);
      	gtk_container_add (GTK_CONTAINER (goto_chart_window), vbox);
      	gtk_widget_show (vbox);
      	
      	goto_chart_clist = gtk_clist_new_with_titles (4, text);
      	gtk_clist_set_column_width(GTK_CLIST(goto_chart_clist), 0, 70);
      	gtk_clist_set_column_width(GTK_CLIST(goto_chart_clist), 1, 200);
      	gtk_clist_set_column_width(GTK_CLIST(goto_chart_clist), 2, 70);
      	gtk_clist_set_column_width(GTK_CLIST(goto_chart_clist), 3, 70);
      	gtk_clist_set_selection_mode (GTK_CLIST (goto_chart_clist), GTK_SELECTION_SINGLE);
       	gtk_clist_set_policy (GTK_CLIST (goto_chart_clist), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
      	gtk_box_pack_start (GTK_BOX (vbox), goto_chart_clist, TRUE, TRUE, 0);
      	gtk_container_border_width (GTK_CONTAINER (goto_chart_clist), 10);
      	gtk_widget_set_usize(GTK_WIDGET (goto_chart_clist), 500, 200);
      	gtk_widget_show (goto_chart_clist);
			    
       	hsep = gtk_hseparator_new();
	gtk_box_pack_start (GTK_BOX (vbox), hsep, FALSE, TRUE, 0);
       	gtk_widget_show(hsep);
        
       	hbox = gtk_hbutton_box_new();
       	gtk_container_border_width (GTK_CONTAINER (hbox), 10);
	gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, TRUE, 0);
	gtk_hbutton_box_set_spacing_default(10);
       	gtk_hbutton_box_set_layout_default(GTK_BUTTONBOX_END);
	gtk_widget_show(hbox);
      	
	button = gtk_button_new_with_label("OK");
	gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, TRUE, 0);
	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			    GTK_SIGNAL_FUNC (ok_goto_chart), NULL);
	gtk_widget_show (button);
      	
	button2 = gtk_button_new_with_label("Cancel");
      	gtk_box_pack_start (GTK_BOX (hbox), button2, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button2), "clicked",
			    GTK_SIGNAL_FUNC (exit_goto_chart_window), NULL);
      	gtk_widget_show (button2);
      	
      	button3 = gtk_button_new_with_label("Help");
      	gtk_box_pack_start (GTK_BOX (hbox), button3, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button3), "clicked",
			    GTK_SIGNAL_FUNC (help_goto_chart_window), NULL);
      	gtk_widget_show (button3);
      	
      	gtk_clist_freeze (GTK_CLIST (goto_chart_clist));
      	infile = fopen(groupfilename, "rb");
      	if (! infile)
      	{
      		error_message = cant_open_group;
		display_message();
		return;
      	}
	for (tint = 0; tint <= group_size; tint++)
	{
		fread(&tstring, GROUP_RECORDSIZE, 1, infile);
		sscanf(tstring, "%s", tstring2);
		strcpy(tstring, datapath);
		strcat(tstring, tstring2);
   		infile2 = fopen(tstring, "rb");
   		if (infile2)
   		{
   			fread(&tstring, NAME_SIZE, 1, infile2);
			line[1] = tstring;
			fread(&tstring2, SYMBOL_SIZE, 1, infile2);
			line[0] = tstring2;
			fseek(infile2, HEADERSIZE, SEEK_SET);
			fread(&tlong, sizeof(unsigned long), 1, infile2);
			sprintf(tstring5, "%ld", tlong);
			tstring3[0] = tstring5[4];
			tstring3[1] = tstring5[5];
			tstring3[2] = '/';
			tstring3[3] = tstring5[6];
			tstring3[4] = tstring5[7];
			tstring3[5] = '/';
			tstring3[6] = tstring5[0];
			tstring3[7] = tstring5[1];
			tstring3[8] = tstring5[2];
			tstring3[9] = tstring5[3];
			tstring3[10] = 0;
			line[2] = tstring3;
			fseek(infile2, 0L, SEEK_END);
			tlong = ftell(infile2);
			tlong = tlong - HEADERSIZE;
			records = tlong / RECORDSIZE;
			fseek(infile2, (long)(((records - 1) * RECORDSIZE) + HEADERSIZE), SEEK_SET);
			fread(&tlong, sizeof(unsigned long), 1, infile2);
			sprintf(tstring5, "%ld", tlong);
			tstring4[0] = tstring5[4];
			tstring4[1] = tstring5[5];
			tstring4[2] = '/';
			tstring4[3] = tstring5[6];
			tstring4[4] = tstring5[7];
			tstring4[5] = '/';
			tstring4[6] = tstring5[0];
			tstring4[7] = tstring5[1];
			tstring4[8] = tstring5[2];
			tstring4[9] = tstring5[3];
			tstring4[10] = 0;
			line[3] = tstring4;
			gtk_clist_append (GTK_CLIST (goto_chart_clist), line);
			fclose(infile2);
		}
	}
       	fclose(infile);
	GTK_WIDGET_SET_FLAGS(button, GTK_CAN_DEFAULT);
      	gtk_widget_grab_default(button);
	goto_chart_flag = 1;
	gtk_widget_show(goto_chart_window);
	gtk_clist_select_row(GTK_CLIST(goto_chart_clist), group_pointer, 0);
       	gtk_clist_moveto(GTK_CLIST(goto_chart_clist), group_pointer, 0, 0.5, 0);
       	gtk_clist_thaw (GTK_CLIST (goto_chart_clist));
}
/***************************************************************************************/
void style_button_pressed()
{
	extern draw();
	extern int styleflag, pixelspace, entries;
	extern GtkWidget *chart;
	
	
	if (styleflag)
		styleflag--;
	else
	{
		if (pixelspace < 6)
		{
			pixelspace = 6;
			gtk_widget_set_usize(GTK_WIDGET (chart), entries * pixelspace, 0);
		}
		styleflag++;
	}
	draw();
}
/***********************************************************************************/
void expand_chart()
{
	extern int chartflag, pixelspace, entries;
	extern draw();
	extern GtkWidget *chart;
	
	
        if (chartflag != 0)
        {
        	pixelspace++;
       		gtk_widget_set_usize(GTK_WIDGET (chart), entries * pixelspace, 0);
		draw();
	}
}
/***********************************************************************************/
void shrink_chart()
{
	extern int chartflag, styleflag, entries, pixelspace;
	extern draw();
	extern GtkWidget *chart;
	
	  	
  	if (chartflag == 0) 
  		return;
        if (styleflag == 0)
        {
               	if (pixelspace > 1)
               	{
                       	pixelspace--;
       			gtk_widget_set_usize(GTK_WIDGET (chart), entries * pixelspace, 0);
			draw();
		}
	}
	else
	{
		if (pixelspace > 6)
               	{
                       	pixelspace--;
    			gtk_widget_set_usize(GTK_WIDGET (chart), entries * pixelspace, 0);
			draw();
		}
	}
}
/***********************************************************************************/
void next_chart()
{
	extern int open_file_flag, chartflag, group_pointer, group_size, data_window_flag;
	extern int edit_indicators_flag, goto_chart_flag;
	extern load_file(), edit_indicators();
	
	
	if (open_file_flag == 1)
		return;
        if (chartflag == 0)
        	return;
	if (group_pointer + 1 <= group_size)
	{
 		group_pointer = group_pointer + 1;
  		load_file();
	}
	else
	{
 	     	group_pointer = 0;
  	     	load_file();
	}
	if (data_window_flag)
	      	show_data_window();
	if (edit_indicators_flag)
		edit_indicators();
	if (goto_chart_flag)
		goto_chart();
}
/***********************************************************************************/
void previous_chart()
{
	extern int open_file_flag, chartflag, group_pointer, group_size, data_window_flag;
	extern int edit_indicators_flag, goto_chart_flag;
	extern load_file(), edit_indicators();
	
	
	if (open_file_flag == 1)
		return;
       	if (chartflag == 0)
       		return;
	if (group_pointer - 1 >= 0)
	{
		group_pointer = group_pointer - 1;
		load_file();
	}
	else
	{
		group_pointer = group_size;
		load_file();
	}
	if (data_window_flag)
      		show_data_window();
      	if (edit_indicators_flag)
		edit_indicators();
	if (goto_chart_flag)
		goto_chart();
}
/************************************************************************************/
void line_style()
{
	extern int chartflag, styleflag;
	extern draw();
	
	if (chartflag != 0)
	{
        	styleflag = 0;
		draw();	     	        
	}
	else
		styleflag = 0;
}
/************************************************************************************/
void hlc_style()
{
	extern int chartflag, styleflag, pixelspace;
	extern draw();
	
	
	if (chartflag != 0)
	{
        	if (pixelspace < 6)
			pixelspace = 6;
		styleflag = 1;
		draw();
	}
	else
	{
		if (pixelspace < 6)
			pixelspace = 6;
		styleflag = 1;
	}
}
/*************************************************************************************/
void new_init()
{	
	char tstring[250], tstring2[250];
	GtkWidget *hbox, *vbox, *vbox2, *label, *label2, *button, *hsep;
	extern char *grouppath, *datapath, *errorlog, *config_file;
	extern GtkWidget *init_window;
	
	
	strcpy(tstring2, getenv("HOME"));
	
	init_window = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_signal_connect (GTK_OBJECT (init_window), "delete_event",
			    GTK_SIGNAL_FUNC (exit_init_window), NULL);
	gtk_signal_connect (GTK_OBJECT (init_window), "destroy",
			    GTK_SIGNAL_FUNC (exit_init_window), NULL);
	gtk_window_position(GTK_WINDOW (init_window), GTK_WIN_POS_CENTER);
	gtk_window_set_title (GTK_WINDOW (init_window), "Create Directories");
	gtk_widget_set_usize(GTK_WIDGET (init_window), 0, 0);
	
	
	vbox = gtk_vbox_new (FALSE, 10);
	gtk_container_add (GTK_CONTAINER (init_window), vbox);
      	gtk_container_border_width (GTK_CONTAINER (vbox), 0);
      	gtk_widget_show (vbox);
      	
      	vbox2 = gtk_vbox_new (FALSE, 0);
      	gtk_container_border_width (GTK_CONTAINER (vbox2), 10);
      	gtk_box_pack_start (GTK_BOX (vbox), vbox2, FALSE, TRUE, 0);
      	gtk_widget_show (vbox2);
      	
	label = gtk_label_new("Creating my data directories in your home directory.");
	gtk_box_pack_start (GTK_BOX (vbox2), label, FALSE, TRUE, 0);
        gtk_widget_show(label);
        
        label2 = gtk_label_new(tstring2);
	gtk_box_pack_start (GTK_BOX (vbox2), label2, FALSE, TRUE, 0);
        gtk_widget_show(label2);
        
        hsep = gtk_hseparator_new();
	gtk_box_pack_start (GTK_BOX (vbox), hsep, FALSE, TRUE, 0);
        gtk_widget_show(hsep);
        
        hbox = gtk_hbutton_box_new();
        gtk_container_border_width (GTK_CONTAINER (hbox), 10);
      	gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, TRUE, 0);
      	gtk_hbutton_box_set_spacing_default(10);
        gtk_hbutton_box_set_layout_default(GTK_BUTTONBOX_END);
      	gtk_widget_show(hbox);
        
      	button = gtk_button_new_with_label("OK");
      	gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			    GTK_SIGNAL_FUNC (exit_init_window), NULL);
      	gtk_widget_show (button);
      	
      	GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
      	gtk_widget_grab_default (button);
      	gtk_widget_show(init_window);
      	
      	strcpy(tstring, tstring2);
	strcat(tstring, "/gstalker/groups/");
	grouppath = (char *)malloc(sizeof(tstring) + 1);
	strcpy(grouppath, tstring);
	strcpy(tstring, tstring2);
	strcat(tstring, "/gstalker/data/");
	datapath = (char *)malloc(sizeof(tstring) + 1);
	strcpy(datapath, tstring);
	strcpy(tstring, tstring2);
	strcat(tstring, "/gstalker/error.log");
	errorlog = (char *)malloc(sizeof(tstring) + 1);
	strcpy(errorlog, tstring);
	strcpy(tstring, tstring2);
	strcat(tstring, "/gstalker/.config");
	config_file = (char *)malloc(sizeof(tstring) + 1);
	strcpy(config_file, tstring);
	
	strcpy(tstring, tstring2);
	strcat(tstring, "/gstalker");
	mkdir(tstring, 0777);
	strcpy(tstring, tstring2);
	strcat(tstring, "/gstalker/groups");
	mkdir(tstring, 0777);
	strcpy(tstring, tstring2);
	strcat(tstring, "/gstalker/data");
	mkdir(tstring, 0777);
	create_config();
	read_config();
}
/************************************************************************************/
void init()
{
	int tint;
	FILE *infile;
	char tstring[250], tstring2[250];
	extern char *grouppath, *datapath, *errorlog, *config_file;
	
	
	strcpy(tstring2, getenv("HOME"));
      	strcpy(tstring, tstring2);
	strcat(tstring, "/gstalker/groups/");
	grouppath = (char *)malloc(sizeof(tstring) + 1);
	strcpy(grouppath, tstring);
	strcpy(tstring, tstring2);
	strcat(tstring, "/gstalker/data/");
	datapath = (char *)malloc(sizeof(tstring) + 1);
	strcpy(datapath, tstring);
	strcpy(tstring, tstring2);
	strcat(tstring, "/gstalker/error.log");
	errorlog = (char *)malloc(sizeof(tstring) + 1);
	strcpy(errorlog, tstring);
	strcpy(tstring, tstring2);
	strcat(tstring, "/gstalker/.config");
	config_file = (char *)malloc(sizeof(tstring) + 1);
	strcpy(config_file, tstring);
	
	strcpy(tstring, tstring2);
	strcat(tstring, "/gstalker/groups");
	tint = chdir(tstring);
	if (tint != 0)
	{
		strcpy(tstring, tstring2);
		strcat(tstring, "/gstalker/groups");
		mkdir(tstring, 0777);
	}
	strcpy(tstring, tstring2);
	strcat(tstring, "/gstalker/data");
	tint = chdir(tstring);
	if (tint != 0)
	{
		strcpy(tstring, tstring2);
		strcat(tstring, "/gstalker/data");
		mkdir(tstring, 0777);
	}
	infile = fopen(config_file, "r");
	if (infile == NULL)
		create_config();
	read_config();
}
/****************************************************************************************/
void motion_notify_event(GtkWidget *widget, GdkEventMotion *event)
{
	int x, y;
	GdkModifierType state;
	char tstring[250], tstring2[25], tstring3[25];
	extern GtkWidget *data_frame, *chart;
	extern int chartflag, pixelspace, current_height, current_width, volume;
	extern float range, maxlow, *open_array, *high_array, *low_array, *close_array;
	extern long *date_array, *volume_array, *openint_array;
	extern int bottom_enable_flag, date_flag, open_flag, high_flag, low_flag, close_flag;
	extern int volume_flag, openi_flag, entries, volume_button_flag;
	
	
	if (chartflag == 0)
		return;
      	if (bottom_enable_flag == 0)
      		return;
	if (event->is_hint)
      		gdk_window_get_pointer(event->window, &x, &y, &state);
      	else
      	{
      		x = event->x;
      		y = event->y;
      		state = event->state;
      	}
      	current_height = chart->allocation.height - DATECANVAS_SIZE;
      	current_width = chart->allocation.width;
/*      	if (volume_button_flag)
      		current_height = current_height - VOLUME_WINDOW_SIZE;
      	if (volume)
      		current_height = current_height - VOLUME_WINDOW_SIZE;*/
        if (((x / pixelspace) < entries) && (x <= current_width) && (y <= current_height))
      	{
 		if (((y >= current_height - VOLUME_WINDOW_SIZE) && (y <= current_height)) && ((volume > 0) || (volume_button_flag > 0)))
 		{
 			tstring[0] = 0;
       			sprintf(tstring2, "%ld", date_array[(x / pixelspace)]);
        		tstring3[0] = tstring2[4];
        		tstring3[1] = tstring2[5];
        		tstring3[2] = '/';
        		tstring3[3] = tstring2[6];
        		tstring3[4] = tstring2[7];
        		tstring3[5] = '/';
        		tstring3[6] = tstring2[0];
        		tstring3[7] = tstring2[1];
        		tstring3[8] = tstring2[2];
        		tstring3[9] = tstring2[3];
        		tstring3[10] = 0;
        		strcpy(tstring, "D=");
       			strcat(tstring, tstring3);
  			strcat(tstring, " V=");
  			sprintf(tstring2, "%ld", volume_array[(x / pixelspace)]);
      			strcat(tstring, tstring2);
        		gtk_statusbar_push(GTK_STATUSBAR(data_frame), 1, tstring);
 		}
      		else
      		{
      			tstring[0] = 0;
      			if (date_flag)
      			{
       	 			sprintf(tstring2, "%ld", date_array[(x / pixelspace)]);
           			tstring3[0] = tstring2[4];
           			tstring3[1] = tstring2[5];
           			tstring3[2] = '/';
           			tstring3[3] = tstring2[6];
           			tstring3[4] = tstring2[7];
           			tstring3[5] = '/';
           			tstring3[6] = tstring2[0];
           			tstring3[7] = tstring2[1];
           			tstring3[8] = tstring2[2];
           			tstring3[9] = tstring2[3];
           			tstring3[10] = 0;
           			strcpy(tstring, "D=");
       	   			strcat(tstring, tstring3);
        		}
			if (open_flag)
       			{
       	   			strcat(tstring, " O=");
       	   			sprintf(tstring2, "%g", open_array[(x / pixelspace)]);
   				strcat(tstring, tstring2);
   			}
       			if (high_flag)
       			{
	   			strcat(tstring, " H=");
	   			sprintf(tstring2, "%g", high_array[(x / pixelspace)]);
       	   			strcat(tstring, tstring2);
       			}
       			if (low_flag)
       			{
       	   			strcat(tstring, " L=");
	   			sprintf(tstring2, "%g", low_array[(x / pixelspace)]);
       	   			strcat(tstring, tstring2);
       			}
       			if (close_flag)
       			{
       	   			strcat(tstring, " C=");
       	   			if (state & GDK_BUTTON1_MASK)
       	   			{
       	   				y = current_height - y;
       	   				sprintf(tstring2, "%g",((range / current_height) * y) + maxlow);
       	   			}
       	   			else
       	   				sprintf(tstring2, "%g", close_array[(x / pixelspace)]);
       	   			strcat(tstring, tstring2);
       	   		}
       	   		if (volume_flag)
       	   		{
  	   			strcat(tstring, " V=");
  	   			sprintf(tstring2, "%ld", volume_array[(x / pixelspace)]);
       	   			strcat(tstring, tstring2);
       	   		}
       	   		if (openi_flag)
       	   		{
       	   			strcat(tstring, " OI=");
   				sprintf(tstring2, "%ld", openint_array[(x / pixelspace)]);
   				strcat(tstring, tstring2);
   			}
   			gtk_statusbar_push(GTK_STATUSBAR(data_frame), 1, tstring);
      		}
   	}
}
/***************************************************************************************/
void configure_event(GtkWidget *widget, GdkEventConfigure *event)
{
	extern GdkPixmap *pixmap;
	extern draw();
	extern int chartflag;
	
	
	if (pixmap)
		gdk_pixmap_unref(pixmap);
	pixmap = gdk_pixmap_new (widget->window,
				 widget->allocation.width,
				 widget->allocation.height,
				 -1);
	gdk_draw_rectangle (pixmap,
			    widget->style->black_gc,
			    TRUE,
			    0, 0,
			    widget->allocation.width,
			    widget->allocation.height);
	if (chartflag)
		draw();
}
/***************************************************************************************/
void scale_configure_event(GtkWidget *widget, GdkEventConfigure *event)
{
	extern GdkPixmap *pixmap2;
	extern draw();
	extern int chartflag;
	
	
	if (pixmap2)
		gdk_pixmap_unref(pixmap2);
	pixmap2 = gdk_pixmap_new(widget->window,
				 widget->allocation.width,
				 widget->allocation.height,
				 -1);
	gdk_draw_rectangle (pixmap2,
			    widget->style->black_gc,
			    TRUE,
			    0, 0,
			    widget->allocation.width,
			    widget->allocation.height);
	if (chartflag)
		draw();
}
/*************************************************************************************/
void expose_event(GtkWidget *widget, GdkEventExpose *event)
{
	extern GdkPixmap *pixmap;
	
	gdk_draw_pixmap (widget->window,
			 widget->style->fg_gc[GTK_WIDGET_STATE(widget)],
			 pixmap,
			 event->area.x, event->area.y,
			 event->area.x, event->area.y,
			 event->area.width, event->area.height);
}
/*************************************************************************************/
void scale_expose_event(GtkWidget *widget, GdkEventExpose *event)
{
	extern GdkPixmap *pixmap2;
	
	gdk_draw_pixmap (widget->window,
			 widget->style->fg_gc[GTK_WIDGET_STATE(widget)],
			 pixmap2,
			 event->area.x, event->area.y,
			 event->area.x, event->area.y,
			 event->area.width, event->area.height);
}
/****************************************************************************************/
void button_press_event(GtkWidget *widget, GdkEventButton *event)
{
	int x, y, tint, current_width, current_height;
	extern GdkPixmap *pixmap;
	extern GtkWidget *chart, *data_window_clist;
	extern int pixelspace, chartflag, entries, data_window_flag;
	
	if (chartflag == 0)
		return;
	x = event->x;
	y = event->y;
	current_height = chart->allocation.height - DATECANVAS_SIZE;
     	current_width = chart->allocation.width;
	if (((x / pixelspace) < entries) && (x <= current_width) && (y <= current_height))
      	{
		if ((event->button == 1) && (pixmap != NULL) && (data_window_flag != 0))
		{
			tint = x / pixelspace;
			gtk_clist_freeze (GTK_CLIST (data_window_clist));
			gtk_clist_select_row(GTK_CLIST(data_window_clist), tint, 0);
			gtk_clist_moveto(GTK_CLIST(data_window_clist), tint, 0, 0.5, 0);
			gtk_clist_thaw (GTK_CLIST (data_window_clist));
		}
	}
}